require "yaml"
require "active_support/core_ext/hash/keys"

module Dropbox
  module Explorer
    class Credentials
      def initialize(credentials)
        @credentials = credentials
      end

      def parse!
        if @credentials && @credentials[:config_path]
          @credentials = YAML.load(File.read(@credentials[:config_path])).symbolize_keys
        else
          raise ArgumentError, "There is no path for the credentials config file"
        end
      end
    end
  end
end
