require "active_support/core_ext/hash/keys"

module Dropbox
  module Explorer
    class Folder
      def initialize(folder_metadata)
        @folder_metadata = folder_metadata.symbolize_keys
      end

      def get_contents_paths(options = {})
        if @folder_metadata[:contents]
          if options[:only_files]
            @folder_metadata[:contents].map { |content| content unless content['is_dir'] }.compact
          else
            @folder_metadata[:contents]
          end
        else
          raise ArgumentError, "There is no contents for this folder metadata"
        end
      end
    end
  end
end
